Loading...
Searching...
No Matches
BALL::TrajectoryFile Class Reference
Molecular Modeling » File Formats » Molecular Dynamics Trajectory File Formats

`#include <BALL/FORMAT/trajectoryFile.h>`

Inheritance diagram for BALL::TrajectoryFile:

## Public Member Functions

Constructors and Destructor
| TrajectoryFile ()
| Default constructor.
| TrajectoryFile (const String &filename, File::OpenMode open_mode=std::ios::in)
virtual | ~TrajectoryFile ()
| Destructor.
Assignment
virtual void | clear ()
| Clear method.
Predicates
bool | operator== (const TrajectoryFile &file) const
| Equality operator.
Accessors
virtual Size | getNumberOfSnapShots ()
Size | getNumberOfAtoms () const
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Public methods for file handling

Size | number_of_snapshots_
Size | number_of_atoms_
virtual bool | readHeader ()
virtual bool | writeHeader ()
virtual bool | append (const SnapShot &snapshot)
virtual bool | read (SnapShot &snapshot)
virtual bool | flushToDisk (const std::vector< SnapShot > &buffer)

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

Trajectory file format for MD simulation. This is more an interface definition than an actual class, because it would not make too much sense to create yet-another-trajectory-format. This class will be specialized by actual formats, like DCD.

Definition at line 28 of file trajectoryFile.h.

## Constructor & Destructor Documentation

## TrajectoryFile() [1/2]

BALL::TrajectoryFile::TrajectoryFile | ( |  | ) |

Default constructor.

## TrajectoryFile() [2/2]

BALL::TrajectoryFile::TrajectoryFile | ( | const String & | filename,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor requiring a filename and the mode in which this file should be opened.

Parameters

  filename | the name of the file
  open_mode | the mode in which this file should be opened

Exceptions

  Exception::FileNotFound | if the file could not be openend

See also
  File

## ~TrajectoryFile()

virtual BALL::TrajectoryFile::~TrajectoryFile | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## append()

virtual bool BALL::TrajectoryFile::append | ( | const SnapShot & | snapshot | ) |

virtual

Append a SnapShot to an existing file. Note that this method does note update the header.

Parameters

  snapshot | the SnapShot we want to save

Returns
  true, if writing was successful

Reimplemented in BALL::DCDFile, and BALL::TRRFile.

## clear()

virtual void BALL::TrajectoryFile::clear | ( |  | ) |

virtual

Clear method.

Reimplemented from BALL::File.

Reimplemented in BALL::DCDFile, and BALL::TRRFile.

## flushToDisk()

virtual bool BALL::TrajectoryFile::flushToDisk | ( | const std::vector< SnapShot > & | buffer | ) |

virtual

Write several SnapShots to disk.

Parameters

  buffer | a vector of snapshots

Returns
  true, if flushing was successful, false ow.

Exceptions

  File::CannotWrite | if writing to the file failed

Reimplemented in BALL::DCDFile, and BALL::TRRFile.

## getNumberOfAtoms()

Size BALL::TrajectoryFile::getNumberOfAtoms | ( |  | ) | const

get the number of atoms coverd by each snapshot.

Returns
  the number of atoms

## getNumberOfSnapShots()

virtual Size BALL::TrajectoryFile::getNumberOfSnapShots | ( |  | ) |

virtual

get the number of snapshots stored in this instance.

Returns
  the number of snapshots of this instance

Reimplemented in BALL::TRRFile.

## operator==()

bool BALL::TrajectoryFile::operator== | ( | const TrajectoryFile & | file | ) | const

Equality operator.

## read()

virtual bool BALL::TrajectoryFile::read | ( | SnapShot & | snapshot | ) |

virtual

Read the next SnapShot from the file.

Parameters

  snapshot | a buffer for result delivery

Returns
  true if a snapshot could be read, false ow.

Reimplemented in BALL::DCDFile, and BALL::TRRFile.

## readHeader()

virtual bool BALL::TrajectoryFile::readHeader | ( |  | ) |

virtual

Read the header of an existing file.

Returns
  true if the header could be read successfully, false ow.

Reimplemented in BALL::DCDFile, and BALL::TRRFile.

## writeHeader()

virtual bool BALL::TrajectoryFile::writeHeader | ( |  | ) |

virtual

Write a header.

Returns
  true if the header could be written successfully, false ow.

Reimplemented in BALL::DCDFile.

## Member Data Documentation

## number_of_atoms_

Size BALL::TrajectoryFile::number_of_atoms_

protected

Definition at line 128 of file trajectoryFile.h.

## number_of_snapshots_

Size BALL::TrajectoryFile::number_of_snapshots_

protected

Definition at line 125 of file trajectoryFile.h.